<?php

namespace CreoCode\ContaoColumns\Component\FormField;

use Contao\FrontendTemplate;
use Contao\BackendTemplate;

use CreoCode\ContaoColumns\Helper\Helper;

class FormColsEnd extends \Widget
{

	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'form_colsEnd';

    /**
	 * Do not validate
	 */
	public function validate()
	{
		return;
	}

    /**
	 * Set-Type
	 */
	protected $strSet;

	/**
	 * Display a wildcard in the back end
	 * @return string
	 */
	public function parse($arrAttributes=null) {

        $backendColumnView = false;
        if (isset($GLOBALS['_tmp_columns_backend_view']) && $GLOBALS['_tmp_columns_backend_view']) {
            $backendColumnView = true;
        }
        
        if (Helper::isBackend() && !$backendColumnView) {
            $this->Template = new BackendTemplate('be_column_element');
            $this->Template->setColor = '#'.$this->column_color;
            $this->Template->colsetTitle = $GLOBALS['TL_LANG']['MSC']['colsEnd'];
            $this->Template->colsetSubtitle = '<span class="count">'.$GLOBALS['TL_LANG']['MSC']['cols'].': '.$this->column_amount.'</span> | <span class="name">'.$GLOBALS['TL_LANG']['MSC']['name'].': '.$this->column_name.'</span>';
            $this->Template->type = $this->type;
            $this->Template->id = $this->id;
            $this->Template->backendColumnView = $backendColumnView;

            return $this->Template->parse();
        }

        if (\defined('TL_MODE') && 'FE' === TL_MODE) {
            $this->Template = new FrontendTemplate($this->strTemplate);

            $this->Template->class = 'ce_colsEnd'; 
            return $this->Template->parse();
        }

        //return parent::generate();
	}

	/**
	 * Generate content element
	 * @return string
	 */
	public function generate()
	{

	}

	/**
	 * Generate content element
	 * @return string
	 */
	protected function compile()
	{

	}

}
