<?php

namespace CreoCode\ContaoColumns\Component\FormField;

use Contao\PageModel;
use Contao\FrontendTemplate;
use Contao\BackendTemplate;

use CreoCode\ContaoColumns\Helper\Helper;

class FormColsStart extends \Widget
{

	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'form_colsStart';

	/**
	 * Do not validate
	 */
	public function validate()
	{
		return;
	}

    /**
	 * Set-Type
	 */
	protected $strSet;

	/**
	 * Display a wildcard in the back end
	 * @return string
	 */
	public function parse($arrAttributes=null) {

        if(!$this->strSet) {
            $this->strSet = 'flexbox';
        }

        $backendColumnView = false;
        if (isset($GLOBALS['_tmp_columns_backend_view']) && $GLOBALS['_tmp_columns_backend_view']) {
            $backendColumnView = true;
        }
        
        if (Helper::isBackend() && !$backendColumnView) {
            $this->Template = new BackendTemplate('be_column_element');
            $this->Template->setColor = '#'.$this->column_color;
            $this->Template->colsetTitle = $GLOBALS['TL_LANG']['MSC']['colsStart'];
            $this->Template->colsetSubtitle = '<span class="count">'.$GLOBALS['TL_LANG']['MSC']['cols'].': '.$this->column_amount.'</span> | <span class="name">'.$GLOBALS['TL_LANG']['MSC']['name'].': '.$this->column_name.'</span>';
            $this->Template->colsetParent = $this->column_parent;
            $this->Template->type = $this->type;
            $this->Template->id = $this->id;
            $this->Template->backendColumnView = $backendColumnView;

            return $this->Template->parse();
		}

        if (\defined('TL_MODE') && 'FE' === TL_MODE) {
            $this->Template = new FrontendTemplate($this->strTemplate);

            $columns = $this->column_amount;

            // Gap
            $gapArray = '';
            $containermarginhorizontal = 0;
            $containermarginvertical = 0;
            if($this->column_usecustomgap == 1 && $this->column_gap) {
                $gapArray = unserialize($this->column_gap);
                $containermarginhorizontal = $this->column_containermarginhorizontal;
                $containermarginvertical = $this->column_containermarginvertical;
            } else if(isset($GLOBALS['objPage'])) {
                $rootPage = PageModel::findByPk($GLOBALS['objPage']->rootId);
                if($rootPage->column_usegap == 1 && $rootPage->column_gap) {
                    $gapArray = unserialize($rootPage->column_gap);
                    $containermarginhorizontal = $rootPage->column_containermarginhorizontal;
                    $containermarginvertical = $rootPage->column_containermarginvertical;
                }
            }
            $this->Template->gap_col = '';
            $this->Template->gap_row = '';
            if ($gapArray) {
                foreach ($gapArray as $key => $gap) {
                    if ($key !== 'unit') {
                        $this->Template->gap_col .= 'padding-'.$key.':'.$gap.$gapArray['unit'].';';
                        if ($containermarginhorizontal) {
                            if ($key === 'left' || $key === 'right') {
                                $this->Template->gap_row .= 'margin-'.$key.':-'.$gap.$gapArray['unit'].';';
                            }
                        }
                        if ($containermarginvertical) {
                            if ($key === 'top' || $key === 'bottom') {
                                $this->Template->gap_row .= 'margin-'.$key.':-'.$gap.$gapArray['unit'].';';
                            }
                        }
                    }
                }
            }


            $colClasses = '';
            $colSizes = [];
            if (isset($this->column_sizes)) {
                $colSizes = unserialize($this->column_sizes);
            }
            foreach ($colSizes as $size) {
                $colSetSizeArray = unserialize($this->{'columns_'.$size});
                if ($colSetSizeArray[0]['width'] === 'auto') {
                    $colClasses .= ' col-' . $size;
                } else {
                    $colClasses .= ' col-' . $size . '-' . $colSetSizeArray[0]['width'];
                }

                if ($colSetSizeArray[0]['offset'] != NULL) {
                    $colClasses .= ' col-' . $size . '-offset-' . $colSetSizeArray[0]['offset'];
                }
                if ($colSetSizeArray[0]['order'] != NULL) {
                    $colClasses .= ' col-' . $size . '-order-' . $colSetSizeArray[0]['order'];
                }
                if ($colSetSizeArray[0]['align'] != NULL) {
                    $colClasses .= ' col-' . $size . '-align-' . $colSetSizeArray[0]['align'];
                }
            }

            if (unserialize($this->column_expert)[0]['cssClass'] != NULL) {
                $colClasses .= ' ' . unserialize($this->column_expert)[0]['cssClass'];
            }

            // $this->Template->class = 'columns_' . $columns;
            $this->Template->rowClass = '';

            // set id's
            $this->Template->id = $this->id;
            $this->Template->pid = $this->pid;
            $this->Template->column_parent = $this->column_parent;
            $this->Template->sorting = $this->sorting;

            // justify & align
            if ($this->column_justify) {
                $this->Template->rowClass .= ' justify-'.$this->column_justify;
            }
            if ($this->column_align) {
                $this->Template->rowClass .= ' align-'.$this->column_align;
            }

            $this->Template->column = 'ce_colsPart' . ' col_1' . $colClasses . ' first';

            $this->Template->class = 'ce_colsStart'; 
            return $this->Template->parse();
        }

		//return parent::generate();
	}

    /**
     * Display a wildcard in the back end
     * @return string
     */
    public function generate() {

    }

	/**
	 * Generate content element
	 * @return string
	 */
	protected function compile() {

	}

}
