<?php

namespace CreoCode\ContaoColumns\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

class Configuration implements ConfigurationInterface
{
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder('creo_code_contao_columns');

        $treeBuilder->getRootNode()
            ->prototype('array')
                ->children()
                    ->scalarNode('label')
                        ->defaultValue('Default Label')  // Setting a default value
                    ->end()
                    ->arrayNode('breakpoints')
                        ->prototype('scalar')->end()
                        ->defaultValue([
                            'xs' => '0',
                            'sm' => '481px',
                            'md' => '768px',
                            'lg' => '1025px',
                            'xl' => '1281px'
                        ])  // Setting default breakpoints
                    ->end()
                    ->scalarNode('scss')->defaultValue('bundles/creocodecontaocolumns/css/flexbox/flexbox.scss')->end()
                    ->scalarNode('class')->defaultValue('')->end()
                    ->booleanNode('inside')->defaultValue(true)->end()
                    ->booleanNode('gap')->defaultValue(true)->end()
                ->end()
            ->end();
        
        return $treeBuilder;
    }
}