<?php

namespace CreoCode\ContaoColumns\DependencyInjection;

use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\Config\FileLocator;
use Symfony\Component\DependencyInjection\Extension\Extension;
use Symfony\Component\DependencyInjection\Loader\YamlFileLoader;

class CreoCodeContaoColumnsExtension extends Extension
{
    /**
     * {@inheritdoc}
     */
    public function load(array $configs, ContainerBuilder $container)
    {
        $loader = new YamlFileLoader(
            $container,
            new FileLocator(__DIR__.'/../Resources/config')
        );

        $loader->load('config.yml');
        $loader->load('services.yml');
        $loader->load('listeners.yml');

        $projectDir = (string) $container->getParameter('kernel.project_dir');

        // validate and merge configuration
        $configuration = new Configuration($projectDir);
        $config = $this->processConfiguration($configuration, $configs);

        // Do something with the merged configuration
        if(!empty($config)) {
            $container->setParameter('creo_code_contao_columns', $config);
        }
        
    }
}
