<?php

use Contao\Input;
use Contao\System;
use Symfony\Component\HttpFoundation\Request;

use CreoCode\ContaoColumns\Helper\Helper;

/**
 * Backend module
 */
$GLOBALS['BE_MOD']['content']['article_columns'] = array
(
    'tables'                => array('tl_article', 'tl_content'),
    'hideInNavigation'      => true,
);



/**
 * Content Elements
 */
$GLOBALS['TL_CTE']['extendedcolset'] = array(
	'colsStart' => 'CreoCode\ContaoColumns\Component\ContentElement\ColsStart',
	'colsPart' => 'CreoCode\ContaoColumns\Component\ContentElement\ColsPart',
	'colsEnd' => 'CreoCode\ContaoColumns\Component\ContentElement\ColsEnd'
);

/**
 * Form Fields
 */
$GLOBALS['TL_FFL']['formColsStart'] = 'CreoCode\ContaoColumns\Component\FormField\FormColsStart';
$GLOBALS['TL_FFL']['formColsPart'] = 'CreoCode\ContaoColumns\Component\FormField\FormColsPart';
$GLOBALS['TL_FFL']['formColsEnd'] = 'CreoCode\ContaoColumns\Component\FormField\FormColsEnd';

/**
 * Hooks
 */
$GLOBALS['TL_HOOKS']['parseBackendTemplate'][] = array('CreoCode\ContaoColumns\Classes\ColumnHooks', 'parseBackendTemplate');
$GLOBALS['TL_HOOKS']['loadDataContainer'][] = array('CreoCode\ContaoColumns\Classes\ColumnHooks', 'addColumnIcon');
$GLOBALS['TL_HOOKS']['clipboardCopy'][] = array('CreoCode\ContaoColumns\Listener\ComponentListener', 'clipboardCopy');
$GLOBALS['TL_HOOKS']['clipboardCopyAll'][] = array('CreoCode\ContaoColumns\Listener\ComponentListener', 'clipboardCopyAll');

$GLOBALS['TL_HOOKS']['generatePage'][] = array('CreoCode\ContaoColumns\Listener\ComponentListener','generatePage');

/**
 * Wrapper Elements
 */
$GLOBALS['TL_WRAPPERS']['start'][] = 'colsStart';
$GLOBALS['TL_WRAPPERS']['separator'][] = 'colsPart';
$GLOBALS['TL_WRAPPERS']['stop'][] = 'colsEnd';

/**
 * Warpper Elements / Form
 */
$GLOBALS['TL_WRAPPERS']['start'][] = 'formColsStart';
$GLOBALS['TL_WRAPPERS']['separator'][] = 'formColsPart';
$GLOBALS['TL_WRAPPERS']['stop'][] = 'formColsEnd';

$GLOBALS['TL_PURGE']['custom']['contao_column'] = array(
	'callback' => array('CreoCode\\ContaoColumns\\Listener\\ComponentListener', 'purgeCache'),
);

$request = System::getContainer()->get('request_stack')->getCurrentRequest() ?? Request::create('');
$isBackend = $request && System::getContainer()->get('contao.routing.scope_matcher')->isBackendRequest($request);
$isFrontend = $request && System::getContainer()->get('contao.routing.scope_matcher')->isFrontendRequest($request);

// css & js
if ($isBackend) {
    // $GLOBALS['TL_CSS'][] = 'assets/creo-code/contao-columns/flexbox.scss|static';
    $GLOBALS['TL_CSS'][] = 'bundles/creocodecontaocolumns/css/backend-global.css|static';
    $GLOBALS['TL_CSS'][] = 'bundles/creocodecontaocolumns/css/backend.css|static';
    //$GLOBALS['TL_JAVASCRIPT'][] = 'bundles/creocodecontaocolumns/js/backend.js|async';
}
