<?php

use Contao\CoreBundle\DataContainer\PaletteManipulator;

// Modify the palette
PaletteManipulator::create()
        ->addLegend('columns_legend', 'layout_legend', PaletteManipulator::POSITION_BEFORE)
        ->addField('column_breakpoints', 'columns_legend', PaletteManipulator::POSITION_APPEND)
        ->addField('column_usegap', 'columns_legend', PaletteManipulator::POSITION_APPEND)
        ->applyToPalette('root', 'tl_page')
        ->applyToPalette('rootfallback', 'tl_page')

;

$GLOBALS['TL_DCA']['tl_page']['config']['oncopy_callback'][] = array(CreoCode\ContaoColumns\Listener\ComponentListener::class,'pageCheck');
$GLOBALS['TL_DCA']['tl_page']['config']['onsubmit_callback'][] = array(CreoCode\ContaoColumns\Listener\ComponentListener::class,'createScssFile');
// $GLOBALS['TL_DCA']['tl_page']['config']['onload_callback'][] = array(CreoCode\ContaoColumns\Listener\ComponentListener::class,'createScssFile');

/**
 * Extend palettes
 */
 $GLOBALS['TL_DCA']['tl_page']['palettes']['__selector__'][] .= 'column_usegap';

/**
 * Extend subpalettes
 */
$GLOBALS['TL_DCA']['tl_page']['subpalettes']['column_usegap'] = 'column_gap,column_containermarginhorizontal,column_containermarginvertical';

/*
 * Add fields
 */
$GLOBALS['TL_DCA']['tl_page']['fields']['column_breakpoints'] = array(
        'label'     => &$GLOBALS['TL_LANG']['tl_page']['column_breakpoints'],
        'inputType' => 'select',
        'options_callback' => array(CreoCode\ContaoColumns\Listener\ComponentListener::class,'getBreakpoints'),
        'eval'      => array('tl_class'=>'w100'),
        'sql'       => "varchar(128) NOT NULL default ''"
);
$GLOBALS['TL_DCA']['tl_page']['fields']['column_usegap'] = array(
        'label'	    => &$GLOBALS['TL_LANG']['tl_page']['column_usegap'],
        'exclude'   => true,
        'inputType' => 'checkbox',
        'eval'      => array('submitOnChange' => true, 'tl_class'=>'clr m12'),
        'sql'       => "char(0) NOT NULL default ''"
);
$GLOBALS['TL_DCA']['tl_page']['fields']['column_gap'] = array(
        'label'     => &$GLOBALS['TL_LANG']['tl_page']['column_gap'],
        'exclude'   => true,
        'inputType' => 'trbl',
        'options'   => array('px', '%', 'em', 'rem'),
        'eval'      => array('includeBlankOption'=>true, 'tl_class'=>'w50'),
        'sql'       => "varchar(128) NOT NULL default ''"
);
$GLOBALS['TL_DCA']['tl_page']['fields']['column_containermarginhorizontal'] = array(
        'label'		=> &$GLOBALS['TL_LANG']['tl_page']['column_containermarginhorizontal'],
        'default'	=> 1,
        'inputType'	=> 'checkbox',
        'eval'		=> array('tl_class'=>'clr w50'),
        'sql'            => "char(1) NOT NULL default '1'"
);
$GLOBALS['TL_DCA']['tl_page']['fields']['column_containermarginvertical'] = array(
        'label'		=> &$GLOBALS['TL_LANG']['tl_page']['column_containermarginvertical'],
        'default'	=> 1,
        'inputType'	=> 'checkbox',
        'eval'		=> array('tl_class'=>'w50'),
        'sql'           => "char(1) NOT NULL default '1'"
);
