// ======================= //
// color
// ======================= //
function columnsColorPicker() {
  const ecColorInput = document.getElementById('ctrl_column_color');
  if (!ecColorInput) return;

  const divColorPrev = document.createElement("div");
  divColorPrev.classList.add("color-preview");
  ecColorInput.parentElement.append(divColorPrev);
  divColorPrev.style.background = '#' + ecColorInput.value;

  const updateColor = () => divColorPrev.style.background = '#' + ecColorInput.value;

  ecColorInput.addEventListener('input', updateColor);

  const ctrlColorButton = document.querySelector('#ctrl_column_color .moor-okButton');
  if (ctrlColorButton) {
      ctrlColorButton.addEventListener('click', updateColor);
  }
}


// ======================= //
// cols preview
// ======================= //
function columnsUpdateCols(container) {
  const cols = container.querySelectorAll('.cols_preview .col');
  const attributes = ['width', 'offset', 'align', 'order'];

  cols.forEach((col, index) => {
      let colClass = `col col_${index + 1}`;
      attributes.forEach(attr => {
        console.log(`tr[data-rowid="${index}"] select[id*="_${attr}"]`);
          // const value = container.querySelector(`select[id*="_${attr}"]`).value;
          const value = container.querySelector(`tr[data-rowid="${index}"] select[id*="_${attr}"]`).value;
          if (value) {
              if (attr === 'width' && value === 'auto') {
                  colClass += ' col';
              } else {
                  colClass += ` col-${attr}-${value}`;
              }
          }
      });
      col.setAttribute('class', colClass);
  });
}

function columnsUpdateRow() {
  const justify = document.getElementById('ctrl_column_justify');
  const align = document.getElementById('ctrl_column_align');
  const allRows = document.querySelectorAll('.widget-columns-container .row');

  allRows.forEach(row => {
      let rowClass = 'row';
      if (justify.value) rowClass += ` justify-${justify.value}`;
      if (align.value) rowClass += ` align-${align.value} align_preview_fix`;
      row.setAttribute('class', rowClass);
  });
}

function columnsCreatePreviewContainer() {
  const columnsContainer = document.getElementsByClassName('widget-columns-container');

  Array.from(columnsContainer).forEach(container => {
      const divColsPreview = document.createElement('div');
      divColsPreview.setAttribute('class', 'cols_preview');
      container.appendChild(divColsPreview);

      const divColsPreviewRow = document.createElement('div');
      divColsPreviewRow.setAttribute('class', 'row');
      divColsPreview.appendChild(divColsPreviewRow);

      const trs = container.querySelectorAll('tbody > tr');
      trs.forEach((_, index) => {
          const col = document.createElement('div');
          col.setAttribute('class', `col col_${index + 1}`);
          col.innerHTML = `<div class="box"><p class="col_index">${index + 1}</p></div>`;
          divColsPreviewRow.appendChild(col);
      });

      columnsUpdateCols(container);
      columnsUpdateRow();
  });

  const selects = document.querySelectorAll('.widget-columns-container select');
  selects.forEach(select => {
      select.addEventListener("change", (ele) => {
          const parent = ele.target.closest(".widget-columns-container");
          columnsUpdateCols(parent);
      });
  });

  const selectJustify = document.getElementById('ctrl_column_justify');
  const selectAlign = document.getElementById('ctrl_column_align');
  const updateRows = () => columnsUpdateRow();

  if (selectJustify) selectJustify.addEventListener("change", updateRows);
  if (selectAlign) selectAlign.addEventListener("change", updateRows);
}


// ======================= //
// fire functions
// ======================= //
window.addEventListener('load', function () {
  columnsColorPicker();
  columnsCreatePreviewContainer();
});